import Quandl
import pandas
import os
import numpy

def save_close_column(filename, data, skip_rows_from_start):
	if os.path.exists(filename):
		os.remove(filename)
	with open(filename, 'w') as f:
		f.write("Close\n")
		for item in data["Close"][skip_rows_from_start - 1:]:
			f.write("%s\n" % item)
			
# Download the data from Quandl.com
# The variable latest contains 4000 records with the following format:
#               Open    High     Low   Close   Volume
#  Date
#  2013-07-15  192.42  194.89  191.68  194.00  5678238
#  2013-07-16  194.04  194.58  192.68  193.85  3747394
#  2013-07-17  194.72  194.89  193.03  194.55  6868411
#  2013-07-18  198.27  200.94  195.99  197.99  8394310
#  2013-07-19  197.91  197.99  193.24  193.54  6998591
# ...
# ending with the present day's data.
data = Quandl.get('GOOG/NYSE_IBM', collapse='daily')
latest = data.tail(4000)
latest.to_csv('latest.csv')
print "Original saved to latest.csv."

# Apply a moving average with the window 10.
moving_average = pandas.rolling_mean(latest, 10)

# Save the Close column to a text file for loading by GeneXproServer.
# Skip the first 10 records which will be nan because we are not back filling
# the moving average.
save_close_column('latest_moving_average.csv', moving_average, 10)
print "Data saved to latest_moving_average.csv."